//http://codelab.fr/5477
import ddf.minim.*;
import ddf.minim.analysis.*;

Minim minim;
AudioInput in;
FFT fft;
PImage imageTest;

void setup() {
  size (640, 480);
  imageTest = loadImage("image640x480.jpg");
  minim = new Minim(this);
  in = minim.getLineIn(Minim.MONO, 4096, 44100);
  fft = new FFT(in.left.size(), 44100);
  noFill();
  imageTest.loadPixels();
}

void draw() {
  background(255);
  fft.forward(in.left);
  loadPixels();
  for (int i = 0; i < width; i++) {
    float amplitude = 0;
    for (int j = 0; j < 8; j++) { // Somme des 8 valeurs
      amplitude += fft.getFreq(i * 8 + j);
    }
    for (int j = 0; j < height; j++) {
      pixels[j * width + i] = imageTest.pixels[((j + (int)amplitude) % height) * width + i];
    }
  }
  updatePixels();
}

void stop() {
  in.close();
  minim.stop();
  super.stop();
}

